#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "konstanten.h"
#include "funktionen.h"
#include "cpu_sps.h"

extern	StruturCode *BCode;
extern 	char Befehle[BEREICH_BE_TY][LAENGE_STR];
extern 	char Typen [BEREICH_BE_TY][LAENGE_STR];
extern   CPU_sps* CPU;
extern 	char  FehlerMeldung[11][80];

short getBefehlsCode(char *BefehlsStr); 	 	// Befehle  z.B. U,O,S,R 
short getOperandenCode(char *OperandenStr); 	//Operanden  z.B. E,A,M
void ZeileZerlegen(char *pStrZeile,char *MarkeStr,char *BefehlStr,char *OperandStr,char *WertStr);
short BytePunktBit_toWert(char *ByteBitStr);

int FNr;

struct MarkenStruct
{	short NetzwerkNr;
	short pCZeiger;
	char MarkeName[10];
};

const int MaxMarken=50000;
MarkenStruct * Marke= new MarkenStruct[MaxMarken];
int AnzahlMarken=0;
char Bemerkung[80]="";
void FehlerMeldungen(char *FehlerMeldungStr,const char* Bemerkung, int NetzwerkNr,int Zeile)
{	char FMeldung[100];
	sprintf(FMeldung,"Netzwerk:%3d Zeile:%3d Fehler:%s %s\n",NetzwerkNr,Zeile,FehlerMeldungStr,Bemerkung);
   if(FNr<11)
	{	strcpy(FehlerMeldung[FNr],FMeldung);
		FNr++;
	}
}


void vorCompiler(char* CStr_zwischenSpeicher) // Adressen von Marken ermitteln
{char *pStrZeile,*pChar;
 	char MarkeStr[40],BefehlStr[40],OperandStr[40],WertStr[40];
	short BefehlsCode,OperandenCode;
	int NetzwerkNr;
	int pC=0;
	AnzahlMarken=NetzwerkNr=pC=0;
	memset(Marke,0,sizeof(MarkenStruct)*MaxMarken);
	pStrZeile=GenullteStringsAusgeben(CStr_zwischenSpeicher);
	while(pStrZeile!=NULL)
	{	if(pStrZeile=="$")
			goto NeueZeile;
		ZeileZerlegen(pStrZeile,MarkeStr,BefehlStr,OperandStr,WertStr);
		BefehlsCode=getBefehlsCode(BefehlStr);
		OperandenCode=getOperandenCode(OperandStr);
		if(*MarkeStr>0)
		{ pChar=MarkeStr;
		  pChar=strchr(pChar,':');
		  *pChar=0;
		  AnzahlMarken++;
		  pC++;
		  Marke[AnzahlMarken].NetzwerkNr=NetzwerkNr;
		  Marke[AnzahlMarken].pCZeiger=pC;
		  strcpy(Marke[AnzahlMarken].MarkeName,MarkeStr);
		}
		if(BefehlsCode)
			 pC++;
		if(BefehlsCode==NE && *OperandStr>0)
		{  IntegerZahl(OperandStr,0,255,NetzwerkNr);
			pC++;
		}
		else if(OperandenCode)
			pC++;
		if(*WertStr>0)
			pC++;
NeueZeile:		
		pStrZeile=GenullteStringsAusgeben(NULL);
	}//ENDE 	while(pStrZeile!=NULL)		
}//ENDE  vorCompiler(char* CStr_zwischenSpeicher)

int Compiler(char* CStr_zwischenSpeicher)
{	char *pStrZeile,*pChar;
 	char MarkeStr[40],BefehlStr[40],OperandStr[40],WertStr[40];
	short BefehlsCode,OperandenCode;
	bool Marke_gefunden;
	int n,Zahl;
	int Zeile=0,NetzwerkNr=0;
	FNr=0;
	int pC=1;
	
	vorCompiler(CStr_zwischenSpeicher); // Adressen von Marken ermitteln
	memset(FehlerMeldung,0,sizeof(FehlerMeldung[0])*11);
	pStrZeile=GenullteStringsAusgeben(CStr_zwischenSpeicher);
	while(pStrZeile!=NULL)
	{	ZeileZerlegen(pStrZeile,MarkeStr,BefehlStr,OperandStr,WertStr);
	//	printf("ZeileZerlegt:%s\t%s\t%s\t%s\n",MarkeStr,BefehlStr,OperandStr,WertStr);
		
		
		Zeile++;
		if(*pStrZeile=='$')
			goto NeueZeile;
		
		BefehlsCode=getBefehlsCode(BefehlStr);
		OperandenCode=getOperandenCode(OperandStr);
		if(*MarkeStr>0)
		{	BCode[pC].Code=IST_SP_MARKE;
			pChar=MarkeStr;
			pChar=strchr(pChar,':');
			*pChar=0;
			strcpy(BCode[pC].MarkeName,MarkeStr);
			pC++;
		}	
		
		
		if(*BefehlStr=='$')
			goto NeueZeile;
		
		switch(BefehlsCode)//=================================================================================
		{ 	case -1:
			 FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
			 goto NeueZeile;
			break;
			case 0: //wenn kein Befehl vorhanden
				 //FehlerMeldungen(pStrZeile,NetzwerkNr,Zeile);
			break;
			case NE:  //Ausnahme
				BCode[pC++].Code=BefehlsCode;
				if(ZahlOk(WertStr,"1234567890") && IntegerZahl(OperandStr,0,255,Zahl))
				{	BCode[pC++].Code=Zahl; // NetzwerkNr
		      	NetzwerkNr=Zahl;
					OperandenCode=0;
					*OperandStr=0;
					Zeile=0;
				}
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case OR: // Ausnahme
				if(OperandenCode>0)
				 	BCode[pC++].Code=BefehlsCode;
				else
				{	BCode[pC++].Code=OR_BLOCK;;
					if(*WertStr>0)
					{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
						goto NeueZeile;
					}
				}
			break;
			case AND:
			case AND_NOT:
			case OR_NOT:
			case SET:
			case RESET:
			case IST:
			case LOAD:
			case LC:
			case TRANSVER:
			case SI_TIMER:
			case SV_TIMER:
			case SE_TIMER:
			case SS_TIMER:
			case SA_TIMER:
			case ZV:
			case ZR:	
			case SPA:
			case SPB:	
				BCode[pC++].Code=BefehlsCode;
			   if(OperandenCode==0 || *WertStr==0) 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case 	AND_KL_AUF:  
			case  OR_KL_AUF:
			case  KL_ZU:
			case  GLEICH:
			case  KLEINER:
			case  KLEINER_GLEICH:
			case  GROESSER:
			case  GROESSER_GLEICH:
			case  UNGLEICH:
			case  PLUS_F:
			case  MINUS_F:
			case	MUL_F:
			case  DIV_F:
			case  NOP0:
			case  NOP1:
			case  TAK:
			case 	BE:
			case 	BEA:
			case 	BEB:
			case 	STS:
			case 	STP:
			case  UW:
			case  OW:
			case  XOW:
			case  SLW:
			case  SRW:
			case  KEW:
			case  KZW:
			case  DUF:
			case 	DEF:
			case  INC:
			case  DEC:
				BCode[pC++].Code=BefehlsCode;
				if(OperandenCode>0 || *WertStr>0) 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			default:
				FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
				goto NeueZeile;
		}//ENDE switch(BefehlsCode)=========================================================================
		
		if(*OperandStr=='$' || *WertStr=='$')
		{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
			goto NeueZeile;
		}				
		switch(OperandenCode)//=============================================================================
		{	case -1:
				FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
				goto NeueZeile;
			break;
			case 0://wenn kein Operand vorhanden ist
			if(*WertStr>0) 
			{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
				goto NeueZeile;
			}
			break;
			case EINGANG:
			case AUSGANG:
			case MERKER:
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,".01234567890") && WerteBereich_PK(WertStr,0,255,'.',0,7))
					BCode[pC++].Code=BytePunktBit_toWert(WertStr);
				else
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case  OB:
			case  PB: 
			case  FB: 
			case  SB:
			case 	TIMER: 
			case	ZAEHLER:
			case  E_BYTE: 
			case  A_BYTE: 
			case  M_BYTE:
			case	K_B_ZAHL:	
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,"1234567890") && IntegerZahl(WertStr,0,255,Zahl))
					BCode[pC++].Code=Zahl;
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case  E_WORD:
			case  A_WORD:
			case  M_WORD:
			case  K_F_ZAHL:
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,"-+1234567890") && IntegerZahl(WertStr,-32768,32767,Zahl))
					BCode[pC++].Code=Zahl;
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case  B_F_ZAHL:
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,"-+1234567890") && IntegerZahl(WertStr,-128,127,Zahl))
					BCode[pC++].Code=Zahl;
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case  K_H_ZAHL:
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,"0123456789ABCDEF"))
					BCode[pC++].Code=CPU->HexToDez(WertStr);
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case  K_M_ZAHL:
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,"01"))
					BCode[pC++].Code=CPU->BinToDez(WertStr);
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case K_Y_ZAHL:
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,",0123456789") && WerteBereich_PK(WertStr,0,255,',',0,255))
					BCode[pC++].Code=CPU->KyToZahl(WertStr);
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case 	K_TIMER:
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,".0123456789") && WerteBereich_PK(WertStr,0,999,'.',0,3))
					BCode[pC++].Code=KT_DezToBCD(WertStr);
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case K_ZAEHLER:
				BCode[pC++].Code=OperandenCode;
				if(ZahlOk(WertStr,"0123456789") && IntegerZahl(WertStr,0,999,Zahl))
					BCode[pC++].Code=KZ_DezToBCD(WertStr);
				else 
				{	FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			case GLEICH_MARKE:
				BCode[pC++].Code=OperandenCode;
				Marke_gefunden=false;
				for(n=1;n<=AnzahlMarken;n++)
				{	if(Marke[n].NetzwerkNr==NetzwerkNr)
		  			{	if(!strcmp(Marke[n].MarkeName,WertStr))
						{	BCode[pC].Code=Marke[n].pCZeiger;
							strcpy(BCode[pC++].MarkeName,WertStr);
							Marke_gefunden=true;
						}
					}
				}
				if(Marke_gefunden==false)
				{	
					FehlerMeldungen(pStrZeile,"< Die Zielmake ist nicht vorhnaden.",NetzwerkNr,Zeile);
					goto NeueZeile;
				}
			break;
			default:
				FehlerMeldungen(pStrZeile,"",NetzwerkNr,Zeile);
		}//ENDEswitch(OperandenCode)=========================================================================
NeueZeile:		
		pStrZeile=GenullteStringsAusgeben(NULL);
	}//ENDE while(pStrZeile!=NULL)
	BCode[0].Code=pC;
	if(FNr==0)
		return BCode[0].Code; // Anzahl Programmcode
	else
		return 0;
}//ENDE int Compiler(char* CStr_zwischenSpeicher)





void ZeileZerlegen(char *pStrZeile,char *MarkeStr,char *BefehlStr,char *OperandStr,char *WertStr)
{	char *pChar,CZwStr[80];
	strcpy(CZwStr,pStrZeile);
	pChar=strtok(CZwStr,TrennZeichen);
	if(pChar)
	{ if(strchr(pChar,':'))
		{	strcpy(MarkeStr,pChar);
			pChar=strtok(NULL,TrennZeichen);
			if(pChar) 
				strcpy(BefehlStr,pChar);  
			else 
				*BefehlStr=0;	
			pChar=strtok(NULL,TrennZeichen);
			if(pChar) 
				strcpy(OperandStr,pChar);  
			else 
				*OperandStr=0;	
			pChar=strtok(NULL,TrennZeichen);
			if(pChar) 
				strcpy(WertStr,pChar);  
			else 
				*WertStr=0;	
		}
		else //if(strchr(pChar,':')==NULL)
		{	*MarkeStr=0;
			if(pChar) 
				strcpy(BefehlStr,pChar);  
			else 
				*BefehlStr=0;	
			pChar=strtok(NULL,TrennZeichen);
			if(pChar) 
				strcpy(OperandStr,pChar);  
			else 
				*OperandStr=0;	
			pChar=strtok(NULL,TrennZeichen);
			if(pChar) 
				strcpy(WertStr,pChar);  
			else 
				*WertStr=0;	
		}// ENDE if(strchr(pChar,':'))
	}//ENDE if(pChar)
}//ENDE ZeileZerlegen(char *pStrZeile,char &MarkeStr,char &BefehlStr,char &OperandStr,char &WertStr)


short getBefehlsCode(char *BefehlsStr)  // Befehle  z.B. U,O,S,R 
{	if(*BefehlsStr>0)
	{	for(int n=BEFEHLE_ANFANG;n<BEFEHLE_ENDE;n++)
		{	if(!strcmp(Befehle[n],BefehlsStr))
		  return n; 
		}
		return -1;
	}
 	return 0;
}//ENDE getBefehlsCode(char *BefehlsStr) 


short getOperandenCode(char *OperandenStr) //Befehle  z.B. E,A,M
{	if(*OperandenStr>0)
	{	for(int n=TYPEN_ANFANG;n<TYPEN_ENDE;n++)
		{  if(!strcmp(Typen[n],OperandenStr)) 
				return n;
		}
		return -1;
	}
	return 0;
}//ENDE getOperandenCode(char *OperandenStr) 

short BytePunktBit_toWert(char *ByteBitStr)
{	short zw=0;
	char *pChar;
	zw=atoi(ByteBitStr)*8;
	pChar=strchr(ByteBitStr,'.');
	if(pChar)
	{	pChar++; // Zeiger hinter Punkt setzen
		zw+=atoi(pChar);
	}
	return zw;
}
