/***************************************************************************
 *   Copyright (C) 2004 by Burkhard Brauer                                 *
 *   BurkhardBrauer@t-online.de                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _KSPS_H_
#define _KSPS_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kmainwindow.h>
#include <qlistbox.h>


/**
 * @short Application Main Window
 * @author Burkhard Brauer <BurkhardBrauer@t-online.de>
 * @version 0.1
 */



class ksps : public KMainWindow
{   Q_OBJECT
	 QPixmap ZeichnungPuffer;
protected:
	char	***pOB_NetzwerkUeberschrift;	//char	*pOB_NetzwerkUeberschrift[256][256] 
	char	***pPB_NetzwerkUeberschrift;	//char	*pPB_NetzwerkUeberschrift[256][256];
	char	***pFB_NetzwerkUeberschrift;	//char	*pFB_NetzwerkUeberschrift[256][256];
	char	***pSB_NetzwerkUeberschrift;	//char	*pSB_NetzwerkUeberschrift[256][256];
	char **pOB_BausteinUeberschrift;
	char **pPB_BausteinUeberschrift;
	char **pFB_BausteinUeberschrift;
	char **pSB_BausteinUeberschrift;
	char ** Netzwerk_Text;
	char ** Netzwerk_Ueberschrift;
	char **pEingaenge_Kommentar;
	char **pAusgaenge_Kommentar;
	char **pMerker_Kommentar;
	char **pTimer_Kommentar;
	char **pZaehler_Kommentar;
	char **pOB_Kommentar;
	char **pPB_Kommentar;
	char **pFB_Kommentar;
	char **pSB_Kommentar;
	
	char  BausteinUeberschrift_Anzeige[80];
	char  NetzwerkUeberschrift_Anzeige[80];
	int	Anzahl_Netzwerk_Speicher[256];
	void keyPressEvent(QKeyEvent*);
	void resizeEvent(QResizeEvent*);
	void paintEvent(QPaintEvent*);
	void closeEvent( QCloseEvent *ev );
public:
	unsigned char EB_Port[256],AB_Port[256]; 
	char *CStr_zwischenSpeicher;
bool  TextInZeilenZerlegenUndCompilieren(int BausteinName,int BausteinNr,char *CStr_zwischenSpeicher);
	void  BefehlsTabelle();
	void 	Baustein_ins_AG_Laden();
	void 	Alle_Bausteine_ins_AG_laden();
	void  SpsTextLaden(QString QDateipfadPlusDateiname_Wahl);
	void 	SpsTextSpeichern();
	void 	SpsTextSpeichernAls();
   void  SpsNeuerBaustein();
	bool ProjektLaden(QString Pfad);
	void	NeuesProjektVorbereiten();
	void  NeuesProjektErzeugen();
	void  ProjektDatenSpeichern();
	void	getTabellenKommentarEAMTZ();
	void 	setTabellenKommentarEAMTZ();
   unsigned int TextFormatiren(char* CStr);
	int NachSprungMarkenScannen(int AnzahlZeilen);
	void ABytes_LED_Anzeige();
	void EBytes_LED_Anzeige();
	void BefehleStrings();
	void StatusStrings();
	void StatusAnzeigePaint();
 	void NetzwerkText_SeicherAnfrodern(int NetzwerkNr,int AnzahlBytes);
	void NetzwerkText_SeicherFreigeben(int NetzwerkNr);
	void NetzwerkTextToEditor(int NetzwerkNr);
	void Editor_InNertwerkTextRetten(int NetzwerkNr);
	void AG_Loeschen();
	void set_status_spinBoxValue(int index);
	int getIndexComboBox(QString QsuchStr);
	int vergleichenBausteineNamen(const char* pBausteinName1,const char* pBausteinName2);
	void sortiereComboBox();
	int FindIndexComboBox(const char *BausteinnamePlusNr);
	void BausteinBefehlsfolge(int BausteinName,int BausteinNr,int BausteinNetzwerkNr);
	void ProjektlLadenToAgUStarten(QString BeispielPfad);
	int StatusZeile;  
  	ksps(void);
  	virtual ~ksps();
public slots:
	void statusComboBox_ttySn_slot(int index);
	void SPS_ProgrammAufrufen();
	void SPS_ProgrammAufrufen_Timer();
	void MenueItem(int);
	void ScrollVer(int);
	void returnPressed_slot();
	void textChanged_slot();
	void get_spinBox_text_NeNr_slot(int);
	void status_spinBox_NeNr_slot(int NetzwerkNr);
	void Ganzen_TextFormatieren();
	void getTimeSlider(int);
	void TimerAuswerten(); // für Timer SE,SI,SA,SS,SV
	void TAnzeige();
	void neuesNetzwerkBtn_clicked();
	void einfuegenNetzwerk_clicked();
	void loescheNetzwerk_clicked();
	void ButtonGroupEB0_pressed(int);
	void ButtonGroupEB0_released(int);
	void PauseButton_pressed();
	void PauseButton_released();
	void ButtonGroupEB1_Toggle(int);
	void StartStopButton_Rb(int ButtonNr);
	void ButtonHexDez_Rb(int);
	void statusComboBox_slot(int);
	void TabWidget_slot(QWidget *);
	void EAMTabelle_slot(int Zeile,int Spalte);
	void TZTabelle_slot(int Zeile,int Spalte);
	void FehlerListBox_slot(int); 
	void loescheFehlerListBoxl_clicked();
};  //ENDE class ksps : public KMainWindow 


#endif // _KSPS_H_
